package fr.insa.clavardator.ui;

import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;

import java.net.URL;
import java.util.ResourceBundle;

public class LoadingScreenController implements Initializable {


	@FXML
	public VBox indicatorOnlyContainer;
	@FXML
	public VBox labeledContainer;
	@FXML
	public Label loadingLabel;
	@FXML
	public StackPane container;

	public void show() {
		container.setVisible(true);
		setLabel(null);
	}

	public void show(String label) {
		container.setVisible(true);
		setLabel(label);
	}

	public void hide() {
		container.setVisible(false);
	}

	public void setLabel(String label) {
		loadingLabel.setText(label);
		final boolean showLabel = label != null && !label.isEmpty();
		labeledContainer.setVisible(showLabel);
		indicatorOnlyContainer.setVisible(!showLabel);
	}

	public ObservableList<String> getRootStyle() {
		return container.getStyleClass();
	}

	@Override
	public void initialize(URL location, ResourceBundle resources) {
		show();
	}
}
