package fr.insa.clavardator.ui.chat;

import fr.insa.clavardator.ui.users.UserActiveIndicatorController;
import fr.insa.clavardator.users.PeerUser;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;

import java.beans.PropertyChangeEvent;
import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;

public class ChatHeaderController implements Initializable {

	@FXML
	private Label remoteUsernameLabel;
	@FXML
	private UserActiveIndicatorController indicatorController;
	private PeerUser user;

	@Override
	public void initialize(URL location, ResourceBundle resources) {
	}

	private void onUsernameChange(PropertyChangeEvent propertyChangeEvent) {
		if (propertyChangeEvent.getPropertyName().equals("username")) {
			final String newUsername = (String) propertyChangeEvent.getNewValue();
			Platform.runLater(() -> remoteUsernameLabel.setText(newUsername));
		}
	}

	public void setRemoteUser(PeerUser remoteUser) {
		if (this.user != null) {
			// remove old observer before setting new user
			this.user.removeObserver(this::onUsernameChange);
		}
		this.user = remoteUser;
		user.addObserver(this::onUsernameChange);
		remoteUsernameLabel.setText(remoteUser.getUsername());
		indicatorController.setUser(remoteUser);
		indicatorController.setSize(10.0);
	}
}
