package fr.insa.clavardator.ui.chat;

import com.jfoenix.controls.JFXButton;
import fr.insa.clavardator.chat.Message;
import fr.insa.clavardator.users.CurrentUser;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.geometry.Pos;
import javafx.scene.control.Label;
import javafx.scene.layout.VBox;

import java.net.URL;
import java.text.DateFormat;
import java.util.ResourceBundle;

public class MessageListItemController implements Initializable {

	@FXML
	private VBox container;
	@FXML
	private JFXButton button;
	@FXML
	private Label timestamp;

	@Override
	public void initialize(URL url, ResourceBundle rb) {

	}

	public void setMessage(Message message) {
		button.setText(message.getText());
		timestamp.setText(DateFormat.getTimeInstance().format(message.getDate()));
		if (message.getSender().id == CurrentUser.getInstance().getId()) {
			container.setAlignment(Pos.CENTER_RIGHT);
			button.getStyleClass().add("message-self");
		} else {
			container.setAlignment(Pos.CENTER_LEFT);
			button.getStyleClass().add("message-other");
		}
	}
}