package fr.insa.clavardator.ui.users;

import fr.insa.clavardator.users.PeerUser;
import fr.insa.clavardator.util.Log;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.shape.Circle;

import java.beans.PropertyChangeEvent;
import java.net.URL;
import java.util.ResourceBundle;

public class UserActiveIndicatorController implements Initializable {

	@FXML
	private Circle circle;
	private PeerUser user;

	@Override
	public void initialize(URL location, ResourceBundle resources) {

	}

	private void updateState(boolean isActive) {
		circle.getStyleClass().clear();
		if (isActive) {
			circle.getStyleClass().add("active-user-dot");
		} else {
			circle.getStyleClass().add("inactive-user-dot");
		}
	}

	private void onStateChange(PropertyChangeEvent propertyChangeEvent) {
		if (propertyChangeEvent.getPropertyName().equals("state")) {
			final PeerUser.State newState = (PeerUser.State) propertyChangeEvent.getNewValue();
			Platform.runLater(() -> updateState(newState == PeerUser.State.CONNECTED));
		}
	}

	public void setUser(PeerUser user) {
		if (this.user != null) {
			// remove old observer before setting new user
			this.user.removeObserver(this::onStateChange);
		}
		this.user = user;
		user.addObserver(this::onStateChange);
		updateState(user.isActive());
	}

	public void setSize(double value) {
		circle.setRadius(value);
	}

}
