package fr.insa.clavardator.users;

import org.jetbrains.annotations.NotNull;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;

public class User implements Serializable {
	private String username;
	protected int id;

	// Make this class observable
	protected final transient PropertyChangeSupport pcs = new PropertyChangeSupport(this);
	public void addObserver(PropertyChangeListener listener) {
		pcs.addPropertyChangeListener(listener);
	}
	public void removeObserver(PropertyChangeListener listener) {
		pcs.removePropertyChangeListener(listener);
	}

	public User() {
	}

	public User(int id) {
		this.id = id;
	}

	public User(int id, String username) {
		this.id = id;
		this.username = username;
	}


	public int getId() {
		return id;
	}

	public String getUsername() {
		return username;
	}

	protected void setUsername(String newUsername) {
		pcs.firePropertyChange("username", this.username, newUsername);
		this.username = newUsername;
	}
}
